diff --git a/tools/env/Makefile b/tools/env/Makefile
index 28b73da..996e75d 100644
--- a/tools/env/Makefile
+++ b/tools/env/Makefile
@@ -24,12 +24,12 @@
 include $(TOPDIR)/config.mk
 
 HOSTSRCS := $(SRCTREE)/lib/crc32.c  fw_env.c  fw_env_main.c
-HEADERS	:= fw_env.h
+HEADERS	:= fw_env.h $(OBJTREE)/include/generated/fw_env_config.h
+FW_ENV_CONFIG ?= fw_env_config.h.in
 
 # Compile for a hosted environment on the target
 HOSTCPPFLAGS  = -idirafter $(SRCTREE)/include \
-		-idirafter $(OBJTREE)/include2 \
-		-idirafter $(OBJTREE)/include \
+		-idirafter $(OBJTREE)/include/generated \
 		-DUSE_HOSTCC
 
 ifeq ($(MTD_VERSION),old)
@@ -42,8 +42,15 @@ all:	$(obj)fw_printenv
 $(obj)fw_printenv:	$(HOSTSRCS) $(HEADERS)
 	$(HOSTCC) $(HOSTCFLAGS_NOPED) $(HOSTLDFLAGS) -o $@ $(HOSTSRCS)
 
+$(OBJTREE)/include/generated/fw_env_config.h: $(FW_ENV_CONFIG)
+	@mkdir -p $(dir $@)
+	@cp -f $< $@
+
+# add additional dependency for .depend
+$(obj).depend: $(OBJTREE)/include/generated/fw_env_config.h
+
 clean:
-	rm -f $(obj)fw_printenv
+	rm -f $(obj)fw_printenv $(OBJTREE)/include/generated/fw_env_config.h
 
 #########################################################################
 
diff --git a/tools/env/fw_env.h b/tools/env/fw_env.h
index 9258c79..c237154 100644
--- a/tools/env/fw_env.h
+++ b/tools/env/fw_env.h
@@ -20,30 +20,10 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  * MA 02111-1307 USA
  */
+#ifndef _FW_ENV_H_
+#define _FW_ENV_H_
 
-/*
- * To build the utility with the run-time configuration
- * uncomment the next line.
- * See included "fw_env.config" sample file
- * for notes on configuration.
- */
-#define CONFIG_FILE     "/etc/fw_env.config"
-
-#define HAVE_REDUND /* For systems with 2 env sectors */
-#define DEVICE1_NAME      "/dev/mtd1"
-#define DEVICE2_NAME      "/dev/mtd2"
-#define DEVICE1_OFFSET    0x0000
-#define ENV1_SIZE         0x4000
-#define DEVICE2_OFFSET    0x0000
-#define ENV2_SIZE         0x4000
-
-#define CONFIG_BAUDRATE		115200
-#define CONFIG_BOOTDELAY	5	/* autoboot after 5 seconds	*/
-#define CONFIG_BOOTCOMMAND							\
-	"bootp; "								\
-	"setenv bootargs root=/dev/nfs nfsroot=${serverip}:${rootpath} "	\
-	"ip=${ipaddr}:${serverip}:${gatewayip}:${netmask}:${hostname}::off; "	\
-	"bootm"
+#include "fw_env_config.h"
 
 extern int   fw_printenv(int argc, char *argv[]);
 extern char *fw_getenv  (char *name);
@@ -54,3 +34,5 @@ extern int fw_env_write(char *name, char *value);
 extern int fw_env_close(void);
 
 extern unsigned	long  crc32	 (unsigned long, const unsigned char *, unsigned);
+
+#endif
diff --git a/tools/env/fw_env_config.h.in b/tools/env/fw_env_config.h.in
new file mode 100644
index 0000000..d4671f0
--- /dev/null
+++ b/tools/env/fw_env_config.h.in
@@ -0,0 +1,65 @@
+/*
+ * (C) Copyright 2002-2008
+ * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
+ *
+ * (C) Copyright 2011
+ * Andreas Bießmann, Corscience GmbH&Co.KG, biessmann@corscience.de
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+/*
+ * This is an example configuration for fw_printenv/fw_setenv
+ *
+ * If you like to specialize your build of fw_printenv you may copy this file,
+ * modifiy it and add FW_ENV_CONFIG define to the make call:
+ *
+ * make O=/tmp/fw_env_build env FW_ENV_CONFIG=/my/special/configuration/header
+ *
+ * If the FW_ENV_CONFIG is not defined, this file will be used
+ */
+
+#ifndef _FW_ENV_CONFIG_H_
+#define _FW_ENV_CONFIG_H_
+
+/*
+ * To build the utility with the run-time configuration
+ * uncomment the next line.
+ * See included "fw_env.config" sample file
+ * for notes on configuration.
+ */
+#define CONFIG_FILE     "/etc/fw_env.config"
+
+#define HAVE_REDUND /* For systems with 2 env sectors */
+#define DEVICE1_NAME      "/dev/mtd1"
+#define DEVICE2_NAME      "/dev/mtd2"
+#define DEVICE1_OFFSET    0x0000
+#define ENV1_SIZE         0x4000
+#define DEVICE2_OFFSET    0x0000
+#define ENV2_SIZE         0x4000
+
+#define CONFIG_BAUDRATE		115200
+#define CONFIG_BOOTDELAY	5	/* autoboot after 5 seconds	*/
+#define CONFIG_BOOTCOMMAND							\
+	"bootp; "								\
+	"setenv bootargs root=/dev/nfs nfsroot=${serverip}:${rootpath} "	\
+	"ip=${ipaddr}:${serverip}:${gatewayip}:${netmask}:${hostname}::off; "	\
+	"bootm"
+
+#endif